diff --git a/gcc/cp/parser.c b/gcc/cp/parser.c
index 93c812f..da475bd 100644
--- a/gcc/cp/parser.c
+++ b/gcc/cp/parser.c
@@ -3280,13 +3280,14 @@ cp_parser_diagnose_invalid_type_name (cp_parser *parser, tree id,
   to specify an argument list. Emit a useful error message.  */
   if (DECL_TYPE_TEMPLATE_P (decl))
     {
-      error_at (location,
-		"invalid use of template-name %qE without an argument list",
-		decl);
+      diagnostic_group d;
+      d.error_at (location,
+		  "invalid use of template-name %qE without an argument list",
+		  decl);
       if (DECL_CLASS_TEMPLATE_P (decl) && cxx_dialect < cxx17)
-	inform (location, "class template argument deduction is only available "
-		"with -std=c++17 or -std=gnu++17");
-      inform (DECL_SOURCE_LOCATION (decl), "%qD declared here", decl);
+	d.inform (location, "class template argument deduction is only "
+		  "available with -std=c++17 or -std=gnu++17");
+      d.inform (DECL_SOURCE_LOCATION (decl), "%qD declared here", decl);
     }
   else if (TREE_CODE (id) == BIT_NOT_EXPR)
     error_at (location, "invalid use of destructor %qD as a type", id);
@@ -3296,19 +3297,20 @@ cp_parser_diagnose_invalid_type_name (cp_parser *parser, tree id,
   else if (!parser->scope)
     {
       /* Issue an error message.  */
+      diagnostic_group d;
       name_hint hint;
       if (TREE_CODE (id) == IDENTIFIER_NODE)
-	hint = lookup_name_fuzzy (id, FUZZY_LOOKUP_TYPENAME, location);
+	hint = lookup_name_fuzzy (id, FUZZY_LOOKUP_TYPENAME, &d, location);
       if (hint)
 	{
 	  gcc_rich_location richloc (location);
 	  richloc.add_fixit_replace (hint.suggestion ());
-	  error_at (&richloc,
-		    "%qE does not name a type; did you mean %qs?",
-		    id, hint.suggestion ());
+	  d.error_at (&richloc,
+		      "%qE does not name a type; did you mean %qs?",
+		      id, hint.suggestion ());
 	}
       else
-	error_at (location, "%qE does not name a type", id);
+	d.error_at (location, "%qE does not name a type", id);
       /* If we're in a template class, it's possible that the user was
 	 referring to a type from a base class.  For example:
 
@@ -3317,18 +3319,18 @@ cp_parser_diagnose_invalid_type_name (cp_parser *parser, tree id,
 
 	 The user should have said "typename A<T>::X".  */
       if (cxx_dialect < cxx11 && id == ridpointers[(int)RID_CONSTEXPR])
-	inform (location, "C++11 %<constexpr%> only available with "
-		"-std=c++11 or -std=gnu++11");
+	d.inform (location, "C++11 %<constexpr%> only available with "
+		  "-std=c++11 or -std=gnu++11");
       else if (cxx_dialect < cxx11 && id == ridpointers[(int)RID_NOEXCEPT])
-	inform (location, "C++11 %<noexcept%> only available with "
-		"-std=c++11 or -std=gnu++11");
+	d.inform (location, "C++11 %<noexcept%> only available with "
+		  "-std=c++11 or -std=gnu++11");
       else if (cxx_dialect < cxx11
 	       && TREE_CODE (id) == IDENTIFIER_NODE
 	       && id_equal (id, "thread_local"))
-	inform (location, "C++11 %<thread_local%> only available with "
-		"-std=c++11 or -std=gnu++11");
+	d.inform (location, "C++11 %<thread_local%> only available with "
+		  "-std=c++11 or -std=gnu++11");
       else if (!flag_concepts && id == ridpointers[(int)RID_CONCEPT])
-	inform (location, "%<concept%> only available with -fconcepts");
+	d.inform (location, "%<concept%> only available with -fconcepts");
       else if (processing_template_decl && current_class_type
 	       && TYPE_BINFO (current_class_type))
 	{
@@ -3353,9 +3355,9 @@ cp_parser_diagnose_invalid_type_name (cp_parser *parser, tree id,
 		    if (TREE_CODE (field) == TYPE_DECL
 			&& DECL_NAME (field) == id)
 		      {
-			inform (location, 
-				"(perhaps %<typename %T::%E%> was intended)",
-				BINFO_TYPE (b), id);
+			d.inform (location,
+				  "(perhaps %<typename %T::%E%> was intended)",
+				  BINFO_TYPE (b), id);
 			break;
 		      }
 		  if (field)
@@ -3370,33 +3372,35 @@ cp_parser_diagnose_invalid_type_name (cp_parser *parser, tree id,
     {
       if (TREE_CODE (parser->scope) == NAMESPACE_DECL)
 	{
+	  diagnostic_group d;
 	  if (cp_lexer_next_token_is (parser->lexer, CPP_LESS))
-	    error_at (location_of (id),
-		      "%qE in namespace %qE does not name a template type",
-		      id, parser->scope);
+	    d.error_at (location_of (id),
+			"%qE in namespace %qE does not name a template type",
+			id, parser->scope);
 	  else if (TREE_CODE (id) == TEMPLATE_ID_EXPR)
-	    error_at (location_of (id),
-		      "%qE in namespace %qE does not name a template type",
-		      TREE_OPERAND (id, 0), parser->scope);
+	    d.error_at (location_of (id),
+			"%qE in namespace %qE does not name a template type",
+			TREE_OPERAND (id, 0), parser->scope);
 	  else
-	    error_at (location_of (id),
-		      "%qE in namespace %qE does not name a type",
-		      id, parser->scope);
+	    d.error_at (location_of (id),
+			"%qE in namespace %qE does not name a type",
+			id, parser->scope);
 	  if (DECL_P (decl))
-	    inform (DECL_SOURCE_LOCATION (decl), "%qD declared here", decl);
+	    d.inform (DECL_SOURCE_LOCATION (decl), "%qD declared here", decl);
 	  else if (decl == error_mark_node)
-	    suggest_alternative_in_explicit_scope (location, id,
+	    suggest_alternative_in_explicit_scope (&d, location, id,
 						   parser->scope);
 	}
       else if (CLASS_TYPE_P (parser->scope)
 	       && constructor_name_p (id, parser->scope))
 	{
 	  /* A<T>::A<T>() */
-	  error_at (location, "%<%T::%E%> names the constructor, not"
-		    " the type", parser->scope, id);
+	  diagnostic_group d;
+	  d.error_at (location, "%<%T::%E%> names the constructor, not"
+		      " the type", parser->scope, id);
 	  if (cp_lexer_next_token_is (parser->lexer, CPP_LESS))
-	    error_at (location, "and %qT has no template constructors",
-		      parser->scope);
+	    d.error_at (location, "and %qT has no template constructors",
+			parser->scope);
 	}
       else if (TYPE_P (parser->scope)
 	       && dependent_scope_p (parser->scope))
@@ -3417,23 +3421,25 @@ cp_parser_diagnose_invalid_type_name (cp_parser *parser, tree id,
 	}
       else if (TYPE_P (parser->scope))
 	{
+	  diagnostic_group d;
 	  if (!COMPLETE_TYPE_P (parser->scope))
+	    // FIXME use d here?
 	    cxx_incomplete_type_error (location_of (id), NULL_TREE,
 				       parser->scope);
 	  else if (cp_lexer_next_token_is (parser->lexer, CPP_LESS))
-	    error_at (location_of (id),
-		      "%qE in %q#T does not name a template type",
-		      id, parser->scope);
+	    d.error_at (location_of (id),
+			"%qE in %q#T does not name a template type",
+			id, parser->scope);
 	  else if (TREE_CODE (id) == TEMPLATE_ID_EXPR)
-	    error_at (location_of (id),
-		      "%qE in %q#T does not name a template type",
-		      TREE_OPERAND (id, 0), parser->scope);
+	    d.error_at (location_of (id),
+			"%qE in %q#T does not name a template type",
+			TREE_OPERAND (id, 0), parser->scope);
 	  else
-	    error_at (location_of (id),
-		      "%qE in %q#T does not name a type",
-		      id, parser->scope);
+	    d.error_at (location_of (id),
+			"%qE in %q#T does not name a type",
+			id, parser->scope);
 	  if (DECL_P (decl))
-	    inform (DECL_SOURCE_LOCATION (decl), "%qD declared here", decl);
+	    d.inform (DECL_SOURCE_LOCATION (decl), "%qD declared here", decl);
 	}
       else
 	gcc_unreachable ();
@@ -18615,11 +18621,13 @@ cp_parser_namespace_name (cp_parser* parser)
     {
       if (!cp_parser_uncommitted_to_tentative_parse_p (parser))
 	{
-	  error_at (token->location, "%qD is not a namespace-name", identifier);
+	  diagnostic_group d;
+	  d.error_at (token->location, "%qD is not a namespace-name",
+		      identifier);
 	  if (namespace_decl == error_mark_node
 	      && parser->scope && TREE_CODE (parser->scope) == NAMESPACE_DECL)
-	    suggest_alternative_in_explicit_scope (token->location, identifier,
-						   parser->scope);
+	    suggest_alternative_in_explicit_scope (&d, token->location,
+						   identifier, parser->scope);
 	}
       cp_parser_error (parser, "expected namespace-name");
       namespace_decl = error_mark_node;
diff --git a/gcc/cp/pt.c b/gcc/cp/pt.c
index 7fcf5d6..e293752 100644
--- a/gcc/cp/pt.c
+++ b/gcc/cp/pt.c
@@ -800,10 +800,11 @@ check_specialization_namespace (tree tmpl)
     return true;
   else
     {
-      if (permerror (input_location,
+      diagnostic_group d;
+      if (d.permerror (input_location,
 		     "specialization of %qD in different namespace", tmpl))
-	inform (DECL_SOURCE_LOCATION (tmpl),
-		"  from definition of %q#D", tmpl);
+	d.inform (DECL_SOURCE_LOCATION (tmpl),
+		  "  from definition of %q#D", tmpl);
       return false;
     }
 }
@@ -2592,15 +2593,16 @@ check_template_variable (tree decl)
     }
   if (template_header_count > wanted)
     {
-      bool warned = pedwarn (DECL_SOURCE_LOCATION (decl), 0,
-			     "too many template headers for %qD "
-	                     "(should be %d)",
-			     decl, wanted);
+      diagnostic_group d;
+      bool warned = d.pedwarn (DECL_SOURCE_LOCATION (decl), 0,
+			       "too many template headers for %qD "
+			       "(should be %d)",
+			       decl, wanted);
       if (warned && CLASS_TYPE_P (ctx)
 	  && CLASSTYPE_TEMPLATE_SPECIALIZATION (ctx))
-	inform (DECL_SOURCE_LOCATION (decl),
-		"members of an explicitly specialized class are defined "
-		"without a template header");
+	d.inform (DECL_SOURCE_LOCATION (decl),
+		  "members of an explicitly specialized class are defined "
+		  "without a template header");
     }
 }
 
@@ -2724,14 +2726,15 @@ warn_spec_missing_attributes (tree tmpl, tree spec, tree attrlist)
   if (!nattrs)
     return;
 
-  if (warning_at (DECL_SOURCE_LOCATION (spec), OPT_Wmissing_attributes,
-		  "explicit specialization %q#D may be missing attributes",
-		  spec))
-    inform (DECL_SOURCE_LOCATION (tmpl),
-	    nattrs > 1
-	    ? G_("missing primary template attributes %s")
-	    : G_("missing primary template attribute %s"),
-	    pp_formatted_text (&str));
+  diagnostic_group d;
+  if (d.warning_at (DECL_SOURCE_LOCATION (spec), OPT_Wmissing_attributes,
+		    "explicit specialization %q#D may be missing attributes",
+		    spec))
+    d.inform (DECL_SOURCE_LOCATION (tmpl),
+	      nattrs > 1
+	      ? G_("missing primary template attributes %s")
+	      : G_("missing primary template attribute %s"),
+	      pp_formatted_text (&str));
 }
 
 /* Check to see if the function just declared, as indicated in
@@ -3070,11 +3073,12 @@ check_explicit_specialization (tree declarator,
 	  if (TREE_CODE (decl) == FUNCTION_DECL
 	      && DECL_HIDDEN_FRIEND_P (tmpl))
 	    {
-	      if (pedwarn (DECL_SOURCE_LOCATION (decl), 0,
-			   "friend declaration %qD is not visible to "
-			   "explicit specialization", tmpl))
-		inform (DECL_SOURCE_LOCATION (tmpl),
-			"friend declaration here");
+	      diagnostic_group d;
+	      if (d.pedwarn (DECL_SOURCE_LOCATION (decl), 0,
+			     "friend declaration %qD is not visible to "
+			     "explicit specialization", tmpl))
+		d.inform (DECL_SOURCE_LOCATION (tmpl),
+			  "friend declaration here");
 	    }
 	  else if (!ctype && !is_friend
 		   && CP_DECL_CONTEXT (decl) == current_namespace)
@@ -4891,10 +4895,11 @@ process_partial_specialization (tree decl)
 	   && TMPL_ARGS_DEPTH (specargs) == 1
 	   && !get_partial_spec_bindings (maintmpl, maintmpl, specargs))
     {
-      if (permerror (input_location, "partial specialization %qD is not "
-		     "more specialized than", decl))
-	inform (DECL_SOURCE_LOCATION (maintmpl), "primary template %qD",
-		maintmpl);
+      diagnostic_group d;
+      if (d.permerror (input_location, "partial specialization %qD is not "
+		       "more specialized than", decl))
+	d.inform (DECL_SOURCE_LOCATION (maintmpl), "primary template %qD",
+		  maintmpl);
     }
 
   /* [temp.class.spec]
@@ -9352,8 +9357,9 @@ lookup_template_class_1 (tree d1, tree arglist, tree in_decl, tree context,
         {
           if (complain & tf_error)
             {
-              error ("template constraint failure");
-              diagnose_constraints (input_location, gen_tmpl, arglist);
+	      diagnostic_group d;
+	      d.error ("template constraint failure");
+	      diagnose_constraints (&d, input_location, gen_tmpl, arglist);
             }
           return error_mark_node;
         }
@@ -9710,8 +9716,9 @@ finish_template_variable (tree var, tsubst_flags_t complain)
     {
       if (complain & tf_error)
 	{
-	  error ("use of invalid variable template %qE", var);
-	  diagnose_constraints (location_of (var), templ, arglist);
+	  diagnostic_group d;
+	  d.error ("use of invalid variable template %qE", var);
+	  diagnose_constraints (&d, location_of (var), templ, arglist);
 	}
       return error_mark_node;
     }
@@ -26886,27 +26893,28 @@ do_auto_deduction (tree type, tree init, tree auto_node,
           {
             if (complain & tf_warning_or_error)
               {
+		diagnostic_group d;
                 switch (context)
                   {
                   case adc_unspecified:
 		  case adc_unify:
-                    error("placeholder constraints not satisfied");
+		    d.error("placeholder constraints not satisfied");
                     break;
                   case adc_variable_type:
 		  case adc_decomp_type:
-                    error ("deduced initializer does not satisfy "
-                           "placeholder constraints");
+		    d.error ("deduced initializer does not satisfy "
+			     "placeholder constraints");
                     break;
                   case adc_return_type:
-                    error ("deduced return type does not satisfy "
-                           "placeholder constraints");
+		    d.error ("deduced return type does not satisfy "
+			     "placeholder constraints");
                     break;
                   case adc_requirement:
-		    error ("deduced expression type does not satisfy "
-                           "placeholder constraints");
+		    d.error ("deduced expression type does not satisfy "
+			     "placeholder constraints");
                     break;
                   }
-                diagnose_constraints (input_location, constr, targs);
+		diagnose_constraints (&d, input_location, constr, targs);
               }
             return error_mark_node;
           }
diff --git a/gcc/cp/search.c b/gcc/cp/search.c
index c2860b0..7eb501f 100644
--- a/gcc/cp/search.c
+++ b/gcc/cp/search.c
@@ -1911,10 +1911,11 @@ check_final_overrider (tree overrider, tree basefn)
 	/* GNU extension, allow trivial pointer conversions such as
 	   converting to void *, or qualification conversion.  */
 	{
-	  if (pedwarn (DECL_SOURCE_LOCATION (overrider), 0,
-		       "invalid covariant return type for %q#D", overrider))
-	    inform (DECL_SOURCE_LOCATION (basefn),
-		    "overridden function is %q#D", basefn);
+	  diagnostic_group d;
+	  if (d.pedwarn (DECL_SOURCE_LOCATION (overrider), 0,
+			 "invalid covariant return type for %q#D", overrider))
+	    d.inform (DECL_SOURCE_LOCATION (basefn),
+		      "overridden function is %q#D", basefn);
 	}
       else
 	fail = 2;
@@ -1927,15 +1928,17 @@ check_final_overrider (tree overrider, tree basefn)
     {
       if (fail == 1)
 	{
-	  error ("invalid covariant return type for %q+#D", overrider);
-	  inform (DECL_SOURCE_LOCATION (basefn),
-		  "overridden function is %q#D", basefn);
+	  diagnostic_group d;
+	  d.error ("invalid covariant return type for %q+#D", overrider);
+	  d.inform (DECL_SOURCE_LOCATION (basefn),
+		    "overridden function is %q#D", basefn);
 	}
       else
 	{
-	  error ("conflicting return type specified for %q+#D", overrider);
-	  inform (DECL_SOURCE_LOCATION (basefn),
-		  "overridden function is %q#D", basefn);
+	  diagnostic_group d;
+	  d.error ("conflicting return type specified for %q+#D", overrider);
+	  d.inform (DECL_SOURCE_LOCATION (basefn),
+		    "overridden function is %q#D", basefn);
 	}
       DECL_INVALID_OVERRIDER_P (overrider) = 1;
       return 0;
@@ -1949,9 +1952,10 @@ check_final_overrider (tree overrider, tree basefn)
 
   if (!comp_except_specs (base_throw, over_throw, ce_derived))
     {
-      error ("looser throw specifier for %q+#F", overrider);
-      inform (DECL_SOURCE_LOCATION (basefn),
-	      "overridden function is %q#F", basefn);
+      diagnostic_group d;
+      d.error ("looser throw specifier for %q+#F", overrider);
+      d.inform (DECL_SOURCE_LOCATION (basefn),
+		"overridden function is %q#F", basefn);
       DECL_INVALID_OVERRIDER_P (overrider) = 1;
       return 0;
     }
@@ -1962,9 +1966,10 @@ check_final_overrider (tree overrider, tree basefn)
       && !tx_safe_fn_type_p (base_type)
       && !tx_safe_fn_type_p (over_type))
     {
-      error ("conflicting type attributes specified for %q+#D", overrider);
-      inform (DECL_SOURCE_LOCATION (basefn),
-	      "overridden function is %q#D", basefn);
+      diagnostic_group d;
+      d.error ("conflicting type attributes specified for %q+#D", overrider);
+      d.inform (DECL_SOURCE_LOCATION (basefn),
+		"overridden function is %q#D", basefn);
       DECL_INVALID_OVERRIDER_P (overrider) = 1;
       return 0;
     }
@@ -1978,36 +1983,40 @@ check_final_overrider (tree overrider, tree basefn)
       && !lookup_attribute ("transaction_safe_dynamic",
 			    DECL_ATTRIBUTES (basefn)))
     {
-      error_at (DECL_SOURCE_LOCATION (overrider),
-		"%qD declared %<transaction_safe_dynamic%>", overrider);
-      inform (DECL_SOURCE_LOCATION (basefn),
-	      "overriding %qD declared %<transaction_safe%>", basefn);
+      diagnostic_group d;
+      d.error_at (DECL_SOURCE_LOCATION (overrider),
+		  "%qD declared %<transaction_safe_dynamic%>", overrider);
+      d.inform (DECL_SOURCE_LOCATION (basefn),
+		"overriding %qD declared %<transaction_safe%>", basefn);
     }
 
   if (DECL_DELETED_FN (basefn) != DECL_DELETED_FN (overrider))
     {
       if (DECL_DELETED_FN (overrider))
 	{
-	  error ("deleted function %q+D overriding non-deleted function",
-		 overrider);
-	  inform (DECL_SOURCE_LOCATION (basefn),
+	  diagnostic_group d;
+	  d.error ("deleted function %q+D overriding non-deleted function",
+		   overrider);
+	  d.inform (DECL_SOURCE_LOCATION (basefn),
 		  "overridden function is %qD", basefn);
 	  maybe_explain_implicit_delete (overrider);
 	}
       else
 	{
-	  error ("non-deleted function %q+D overriding deleted function",
-		 overrider);
-	  inform (DECL_SOURCE_LOCATION (basefn),
-		  "overridden function is %qD", basefn);
+	  diagnostic_group d;
+	  d.error ("non-deleted function %q+D overriding deleted function",
+		   overrider);
+	  d.inform (DECL_SOURCE_LOCATION (basefn),
+		    "overridden function is %qD", basefn);
 	}
       return 0;
     }
   if (DECL_FINAL_P (basefn))
     {
-      error ("virtual function %q+D overriding final function", overrider);
-      inform (DECL_SOURCE_LOCATION (basefn),
-	      "overridden function is %qD", basefn);
+      diagnostic_group d;
+      d.error ("virtual function %q+D overriding final function", overrider);
+      d.inform (DECL_SOURCE_LOCATION (basefn),
+		"overridden function is %qD", basefn);
       return 0;
     }
   return 1;
@@ -2089,8 +2098,9 @@ look_for_overrides_r (tree type, tree fndecl)
 	{
 	  /* A static member function cannot match an inherited
 	     virtual member function.  */
-	  error ("%q+#D cannot be declared", fndecl);
-	  error ("  since %q+#D declared in base class", fn);
+	  diagnostic_group d;
+	  d.error ("%q+#D cannot be declared", fndecl);
+	  d.error ("  since %q+#D declared in base class", fn);
 	}
       else
 	{
diff --git a/gcc/cp/tree.c b/gcc/cp/tree.c
index 1cf3269..175c631 100644
--- a/gcc/cp/tree.c
+++ b/gcc/cp/tree.c
@@ -4031,22 +4031,24 @@ maybe_warn_parm_abi (tree t, location_t loc)
       && classtype_has_non_deleted_move_ctor (t))
     {
       bool w;
+      diagnostic_group d;
       if (flag_abi_version > 12)
-	w = warning_at (loc, OPT_Wabi, "-fabi-version=13 (GCC 8.2) fixes the "
-			"calling convention for %qT, which was accidentally "
-			"changed in 8.1", t);
+	w = d.warning_at (loc, OPT_Wabi, "-fabi-version=13 (GCC 8.2) fixes the "
+			  "calling convention for %qT, which was accidentally "
+			  "changed in 8.1", t);
       else
-	w = warning_at (loc, OPT_Wabi, "-fabi-version=12 (GCC 8.1) accident"
-			"ally changes the calling convention for %qT", t);
+	w = d.warning_at (loc, OPT_Wabi, "-fabi-version=12 (GCC 8.1) accident"
+			  "ally changes the calling convention for %qT", t);
       if (w)
-	inform (location_of (t), " declared here");
+	d.inform (location_of (t), " declared here");
       return;
     }
 
-  if (warning_at (loc, OPT_Wabi, "the calling convention for %qT changes in "
-		  "-fabi-version=13 (GCC 8.2)", t))
-    inform (location_of (t), " because all of its copy and move "
-	    "constructors are deleted");
+  diagnostic_group d;
+  if (d.warning_at (loc, OPT_Wabi, "the calling convention for %qT changes in "
+		    "-fabi-version=13 (GCC 8.2)", t))
+    d.inform (location_of (t), " because all of its copy and move "
+	      "constructors are deleted");
 }
 
 /* Returns true iff copying an object of type T (including via move
diff --git a/gcc/cp/typeck.c b/gcc/cp/typeck.c
index 072953c..cb0dfea 100644
--- a/gcc/cp/typeck.c
+++ b/gcc/cp/typeck.c
@@ -1691,9 +1691,10 @@ cxx_sizeof_expr (tree e, tsubst_flags_t complain)
       && DECL_ARRAY_PARAMETER_P (e)
       && (complain & tf_warning))
     {
-      if (warning (OPT_Wsizeof_array_argument, "%<sizeof%> on array function "
-		   "parameter %qE will return size of %qT", e, TREE_TYPE (e)))
-	inform (DECL_SOURCE_LOCATION (e), "declared here");
+      diagnostic_group d;
+      if (d.warning (OPT_Wsizeof_array_argument, "%<sizeof%> on array function "
+		     "parameter %qE will return size of %qT", e, TREE_TYPE (e)))
+	d.inform (DECL_SOURCE_LOCATION (e), "declared here");
     }
 
   e = mark_type_use (e);
@@ -3773,9 +3774,10 @@ cp_build_function_call_vec (tree function, vec<tree, va_gc> **params,
           && (complain & tf_error)
           && !constraints_satisfied_p (function))
         {
-          error ("cannot call function %qD", function);
+	  diagnostic_group d;
+	  d.error ("cannot call function %qD", function);
           location_t loc = DECL_SOURCE_LOCATION (function);
-          diagnose_constraints (loc, function, NULL_TREE);
+	  diagnose_constraints (&d, loc, function, NULL_TREE);
           return error_mark_node;
         }
 
@@ -4541,13 +4543,16 @@ cp_build_binary_op (location_t location,
 		   && DECL_ARRAY_PARAMETER_P (first_arg)
 		   && warn_sizeof_array_argument)
 	      && (complain & tf_warning))
-	    if (warning_at (location, OPT_Wsizeof_pointer_div,
-			    "division %<sizeof (%T) / sizeof (%T)%> does "
-			    "not compute the number of array elements",
+	    {
+	      diagnostic_group d;
+	      if (d.warning_at (location, OPT_Wsizeof_pointer_div,
+				"division %<sizeof (%T) / sizeof (%T)%> does "
+				"not compute the number of array elements",
 			    type0, type1))
-	      if (DECL_P (first_arg))
-		inform (DECL_SOURCE_LOCATION (first_arg),
-			"first %<sizeof%> operand was declared here");
+		if (DECL_P (first_arg))
+		  d.inform (DECL_SOURCE_LOCATION (first_arg),
+			    "first %<sizeof%> operand was declared here");
+	    }
 	}
 
       if ((code0 == INTEGER_TYPE || code0 == REAL_TYPE
@@ -4840,12 +4845,15 @@ cp_build_binary_op (location_t location,
 	  else
 	    result_type = type0;
 
-	  if (char_type_p (TREE_TYPE (orig_op1))
-	      && warning (OPT_Wpointer_compare,
-			  "comparison between pointer and zero character "
-			  "constant"))
-	    inform (input_location,
-		    "did you mean to dereference the pointer?");
+	  if (char_type_p (TREE_TYPE (orig_op1)))
+	    {
+	      diagnostic_group d;
+	      if (d.warning (OPT_Wpointer_compare,
+			     "comparison between pointer and zero character "
+			     "constant"))
+		d.inform (input_location,
+			  "did you mean to dereference the pointer?");
+	    }
 	  warn_for_null_address (location, op0, complain);
 	}
       else if (((code1 == POINTER_TYPE || TYPE_PTRDATAMEM_P (type1))
@@ -4860,12 +4868,15 @@ cp_build_binary_op (location_t location,
 	  else
 	    result_type = type1;
 
-	  if (char_type_p (TREE_TYPE (orig_op0))
-	      && warning (OPT_Wpointer_compare,
-			  "comparison between pointer and zero character "
-			  "constant"))
-	    inform (input_location,
-		    "did you mean to dereference the pointer?");
+	  if (char_type_p (TREE_TYPE (orig_op0)))
+	    {
+	      diagnostic_group d;
+	      if (d.warning (OPT_Wpointer_compare,
+			     "comparison between pointer and zero character "
+			     "constant"))
+		inform (input_location,
+			"did you mean to dereference the pointer?");
+	    }
 	  warn_for_null_address (location, op1, complain);
 	}
       else if ((code0 == POINTER_TYPE && code1 == POINTER_TYPE)
@@ -8881,11 +8892,13 @@ convert_for_assignment (tree type, tree rhs,
 		}
 	      else if (fndecl)
 		{
-		  error_at (cp_expr_loc_or_loc (rhs, input_location),
-			    "cannot convert %qH to %qI",
-			    rhstype, type);
-		  inform (get_fndecl_argument_location (fndecl, parmnum),
-			  "  initializing argument %P of %qD", parmnum, fndecl);
+		  diagnostic_group d;
+		  d.error_at (cp_expr_loc_or_loc (rhs, input_location),
+			      "cannot convert %qH to %qI",
+			      rhstype, type);
+		  d.inform (get_fndecl_argument_location (fndecl, parmnum),
+			    "  initializing argument %P of %qD", parmnum,
+			    fndecl);
 		}
 	      else
 		switch (errtype)
@@ -9152,26 +9165,27 @@ maybe_warn_about_returning_address_of_local (tree retval)
 	   || TREE_PUBLIC (whats_returned)))
     {
       bool w = false;
+      diagnostic_group d;
       if (TYPE_REF_P (valtype))
-	w = warning_at (loc, OPT_Wreturn_local_addr,
-			"reference to local variable %qD returned",
-			whats_returned);
+	w = d.warning_at (loc, OPT_Wreturn_local_addr,
+			  "reference to local variable %qD returned",
+			  whats_returned);
       else if (is_std_init_list (valtype))
-	w = warning_at (loc, OPT_Winit_list_lifetime,
-			"returning local initializer_list variable %qD "
-			"does not extend the lifetime of the underlying array",
-			whats_returned);
+	w = d.warning_at (loc, OPT_Winit_list_lifetime,
+			  "returning local initializer_list variable %qD does"
+			  "not extend the lifetime of the underlying array",
+			  whats_returned);
       else if (TREE_CODE (whats_returned) == LABEL_DECL)
-	w = warning_at (loc, OPT_Wreturn_local_addr,
-			"address of label %qD returned",
-			whats_returned);
+	w = d.warning_at (loc, OPT_Wreturn_local_addr,
+			  "address of label %qD returned",
+			  whats_returned);
       else
-	w = warning_at (loc, OPT_Wreturn_local_addr,
-			"address of local variable %qD returned",
-			whats_returned);
+	w = d.warning_at (loc, OPT_Wreturn_local_addr,
+			  "address of local variable %qD returned",
+			  whats_returned);
       if (w)
-	inform (DECL_SOURCE_LOCATION (whats_returned),
-		"declared here");
+	d.inform (DECL_SOURCE_LOCATION (whats_returned),
+		  "declared here");
       return true;
     }
 
